## NMDeviceMacsec NMDeviceMacsec |

## Functions

NMDevice * | nm_device_macsec_get_parent ()
const char * | nm_device_macsec_get_hw_address ()
guint64 | nm_device_macsec_get_sci ()
guint8 | nm_device_macsec_get_icv_length ()
guint64 | nm_device_macsec_get_cipher_suite ()
guint | nm_device_macsec_get_window ()
guint8 | nm_device_macsec_get_encoding_sa ()
const char * | nm_device_macsec_get_validation ()
gboolean | nm_device_macsec_get_encrypt ()
gboolean | nm_device_macsec_get_protect ()
gboolean | nm_device_macsec_get_include_sci ()
gboolean | nm_device_macsec_get_es ()
gboolean | nm_device_macsec_get_scb ()
gboolean | nm_device_macsec_get_replay_protect ()

## Types and Values

#define | NM_DEVICE_MACSEC_PARENT
#define | NM_DEVICE_MACSEC_HW_ADDRESS
#define | NM_DEVICE_MACSEC_SCI
#define | NM_DEVICE_MACSEC_ICV_LENGTH
#define | NM_DEVICE_MACSEC_CIPHER_SUITE
#define | NM_DEVICE_MACSEC_WINDOW
#define | NM_DEVICE_MACSEC_ENCODING_SA
#define | NM_DEVICE_MACSEC_VALIDATION
#define | NM_DEVICE_MACSEC_ENCRYPT
#define | NM_DEVICE_MACSEC_PROTECT
#define | NM_DEVICE_MACSEC_INCLUDE_SCI
#define | NM_DEVICE_MACSEC_ES
#define | NM_DEVICE_MACSEC_SCB
#define | NM_DEVICE_MACSEC_REPLAY_PROTECT

## Description

## Functions

### nm_device_macsec_get_parent ()

    NMDevice *
    nm_device_macsec_get_parent (NMDeviceMacsec *device);

#### Parameters

device | a NMDeviceMacsec |

#### Returns

the device's parent device.

[transfer none]

Since: 1.6

### nm_device_macsec_get_hw_address ()

    const char *
    nm_device_macsec_get_hw_address (NMDeviceMacsec *device);

Gets the hardware (MAC) address of the NMDeviceMacsec

#### Parameters

device | a NMDeviceMacsec |

#### Returns

the hardware address. This is the internal string used by the device, and must not be modified.

Since: 1.6

### nm_device_macsec_get_sci ()

    guint64
    nm_device_macsec_get_sci (NMDeviceMacsec *device);

Gets the Secure Channel Identifier in use

#### Parameters

device | a NMDeviceMacsec |

#### Returns

the SCI

Since: 1.6

### nm_device_macsec_get_icv_length ()

    guint8
    nm_device_macsec_get_icv_length (NMDeviceMacsec *device);

Gets the length of ICV (Integrity Check Value)

#### Parameters

device | a NMDeviceMacsec |

#### Returns

the length of ICV

Since: 1.6

### nm_device_macsec_get_cipher_suite ()

    guint64
    nm_device_macsec_get_cipher_suite (NMDeviceMacsec *device);

Gets the set of cryptographic algorithms in use

#### Parameters

device | a NMDeviceMacsec |

#### Returns

the set of cryptographic algorithms in use

Since: 1.6

### nm_device_macsec_get_window ()

    guint
    nm_device_macsec_get_window (NMDeviceMacsec *device);

Gets the size of the replay window

#### Parameters

device | a NMDeviceMacsec |

#### Returns

size of the replay window

Since: 1.6

### nm_device_macsec_get_encoding_sa ()

    guint8
    nm_device_macsec_get_encoding_sa (NMDeviceMacsec *device);

Gets the value of the Association Number (0..3) for the Security Association in use.

#### Parameters

device | a NMDeviceMacsec |

#### Returns

the current Security Association

Since: 1.6

### nm_device_macsec_get_validation ()

    const char *
    nm_device_macsec_get_validation (NMDeviceMacsec *device);

Gets the validation mode for incoming packets (strict, check, disabled)

#### Parameters

device | a NMDeviceMacsec |

#### Returns

the validation mode

Since: 1.6

### nm_device_macsec_get_encrypt ()

    gboolean
    nm_device_macsec_get_encrypt (NMDeviceMacsec *device);

Gets whether encryption of transmitted frames is enabled

#### Parameters

device | a NMDeviceMacsec |

#### Returns

whether encryption is enabled

Since: 1.6

### nm_device_macsec_get_protect ()

    gboolean
    nm_device_macsec_get_protect (NMDeviceMacsec *device);

Gets whether protection of transmitted frames is enabled

#### Parameters

device | a NMDeviceMacsec |

#### Returns

whether protection is enabled

Since: 1.6

### nm_device_macsec_get_include_sci ()

    gboolean
    nm_device_macsec_get_include_sci (NMDeviceMacsec *device);

Gets whether the SCI is always included in SecTAG for transmitted frames

#### Parameters

device | a NMDeviceMacsec |

#### Returns

whether the SCI is always included

Since: 1.6

### nm_device_macsec_get_es ()

    gboolean
    nm_device_macsec_get_es (NMDeviceMacsec *device);

Gets whether the ES (End station) bit is enabled in SecTAG for transmitted frames

#### Parameters

device | a NMDeviceMacsec |

#### Returns

whether the ES (End station) bit is enabled

Since: 1.6

### nm_device_macsec_get_scb ()

    gboolean
    nm_device_macsec_get_scb (NMDeviceMacsec *device);

Gets whether the SCB (Single Copy Broadcast) bit is enabled in SecTAG for transmitted frames

#### Parameters

device | a NMDeviceMacsec |

#### Returns

whether the SCB (Single Copy Broadcast) bit is enabled

Since: 1.6

### nm_device_macsec_get_replay_protect ()

    gboolean
    nm_device_macsec_get_replay_protect (NMDeviceMacsec *device);

Gets whether replay protection is enabled

#### Parameters

device | a NMDeviceMacsec |

#### Returns

whether replay protection is enabled

Since: 1.6

## Types and Values

### NM_DEVICE_MACSEC_PARENT

    #define NM_DEVICE_MACSEC_PARENT          "parent"

### NM_DEVICE_MACSEC_HW_ADDRESS

    #define NM_DEVICE_MACSEC_HW_ADDRESS      "hw-address"

### NM_DEVICE_MACSEC_SCI

    #define NM_DEVICE_MACSEC_SCI             "sci"

### NM_DEVICE_MACSEC_ICV_LENGTH

    #define NM_DEVICE_MACSEC_ICV_LENGTH      "icv-length"

### NM_DEVICE_MACSEC_CIPHER_SUITE

    #define NM_DEVICE_MACSEC_CIPHER_SUITE    "cipher-suite"

### NM_DEVICE_MACSEC_WINDOW

    #define NM_DEVICE_MACSEC_WINDOW          "window"

### NM_DEVICE_MACSEC_ENCODING_SA

    #define NM_DEVICE_MACSEC_ENCODING_SA     "encoding-sa"

### NM_DEVICE_MACSEC_VALIDATION

    #define NM_DEVICE_MACSEC_VALIDATION      "validation"

### NM_DEVICE_MACSEC_ENCRYPT

    #define NM_DEVICE_MACSEC_ENCRYPT         "encrypt"

### NM_DEVICE_MACSEC_PROTECT

    #define NM_DEVICE_MACSEC_PROTECT         "protect"

### NM_DEVICE_MACSEC_INCLUDE_SCI

    #define NM_DEVICE_MACSEC_INCLUDE_SCI     "include-sci"

### NM_DEVICE_MACSEC_ES

    #define NM_DEVICE_MACSEC_ES              "es"

### NM_DEVICE_MACSEC_SCB

    #define NM_DEVICE_MACSEC_SCB             "scb"

### NM_DEVICE_MACSEC_REPLAY_PROTECT

    #define NM_DEVICE_MACSEC_REPLAY_PROTECT  "replay-protect"